edu.northwestern.at.utils

## Interface Map3D<R extends java.lang.Comparable,C extends java.lang.Comparable,S extends java.lang.Comparable,V>

- All Known Implementing Classes:
    HashMap3D

      public interface Map3D<R extends java.lang.Comparable,C extends java.lang.Comparable,S extends java.lang.Comparable,V>

  Interface for two dimensional map.

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `clear()` Clear all entries from this map and its child maps.
    `java.util.Set<C>` | `columnKeySet()` Get column key set.
    `boolean` | `containsKey(CompoundKey key)` Determine if map contains a compound key.
    `boolean` | `containsKeys(java.lang.Object rowKey, java.lang.Object columnKey, java.lang.Object sliceKey)` Determine if map contains a key pair.
    `V` | `get(CompoundKey key)` Get value at specified CompoundKey position.
    `V` | `get(java.lang.Object rowKey, java.lang.Object columnKey, java.lang.Object sliceKey)` Get value at specified (rowKey, columnKey, sliceKey) position.
    `java.util.Iterator<CompoundKey>` | `iterator()` Get compound key iterator.
    `java.util.Set<CompoundKey>` | `keySet()` Get the compound key set.
    `V` | `put(R rowKey, C columnKey, S sliceKey, V value)` Add value for specified (rowKey, columnKey) .
    `V` | `remove(java.lang.Object rowKey, java.lang.Object columnKey, java.lang.Object sliceKey)` Remove entry at (rowKey, columnKey).
    `java.util.Set<R>` | `rowKeySet()` Get row key set.
    `int` | `size()` Return number of entries.
    `java.util.Set<S>` | `sliceKeySet()` Get slice key set.

- - ### Method Detail

    - #### clear

          void clear()

      Clear all entries from this map and its child maps.

    - #### size

          int size()

      Return number of entries.
      Returns:
        Number of entries in map.

    - #### containsKeys

          boolean containsKeys(java.lang.Object rowKey,
                             java.lang.Object columnKey,
                             java.lang.Object sliceKey)

      Determine if map contains a key pair.
      Parameters:
        `rowKey` - Row key.
        `columnKey` - Column key.
        `sliceKey` - Slice key.
      Returns:
        true if entry exists, false otherwise.

    - #### containsKey

          boolean containsKey(CompoundKey key)

      Determine if map contains a compound key.
      Parameters:
        `key` - Compound key.
      Returns:
        true if entry exists, false otherwise.

    - #### get

          V get(java.lang.Object rowKey,
              java.lang.Object columnKey,
              java.lang.Object sliceKey)

      Get value at specified (rowKey, columnKey, sliceKey) position.
      Parameters:
        `rowKey` - Row key.
        `columnKey` - Column key.
        `sliceKey` - Slice key.
      Returns:
        The value at the specified (rowKey, columnKey, sliceKey) position.

    - #### get

          V get(CompoundKey key)

      Get value at specified CompoundKey position.
      Parameters:
        `key` - Compound key.
      Returns:
        The value at the specified compound key position.

    - #### put

          V put(R rowKey,
              C columnKey,
              S sliceKey,
              V value)

      Add value for specified (rowKey, columnKey) .
      Parameters:
        `rowKey` - Row key.
        `columnKey` - Column key.
        `sliceKey` - Slice key.
        `value` - Value to store.
      Returns:
        Previous value for (rowKey, columnKey, sliceKey). May be null.

    - #### remove

          V remove(java.lang.Object rowKey,
                 java.lang.Object columnKey,
                 java.lang.Object sliceKey)

      Remove entry at (rowKey, columnKey).
      Parameters:
        `rowKey` - Row key.
        `columnKey` - Column key.
      Returns:
        Previous value for (rowKey, columnKey). May be null.

    - #### keySet

          java.util.Set<CompoundKey> keySet()

      Get the compound key set.
      Returns:
        The compound key set.

    - #### rowKeySet

          java.util.Set<R> rowKeySet()

      Get row key set.
      Returns:
        rows key set.

    - #### columnKeySet

          java.util.Set<C> columnKeySet()

      Get column key set.
      Returns:
        column key set.

    - #### sliceKeySet

          java.util.Set<S> sliceKeySet()

      Get slice key set.
      Returns:
        Slice key set.

    - #### iterator

          java.util.Iterator<CompoundKey> iterator()

      Get compound key iterator.
      Returns:
        Compound key iterator.